import '/backend/api_requests/api_calls.dart';
import '/components/molecular_components/throw_exception/throw_exception_widget.dart';
import '/flutter_flow/flutter_flow_util.dart';
import '/custom_code/actions/index.dart' as actions;
import 'login_page_widget.dart' show LoginPageWidget;
import 'package:flutter/material.dart';

class LoginPageModel extends FlutterFlowModel<LoginPageWidget> {
  ///  State fields for stateful widgets in this page.

  final unfocusNode = FocusNode();
  // State field(s) for emailAddress widget.
  FocusNode? emailAddressFocusNode;
  TextEditingController? emailAddressTextController;
  String? Function(BuildContext, String?)? emailAddressTextControllerValidator;
  // State field(s) for password widget.
  FocusNode? passwordFocusNode;
  TextEditingController? passwordTextController;
  late bool passwordVisibility;
  String? Function(BuildContext, String?)? passwordTextControllerValidator;

  @override
  void initState(BuildContext context) {
    passwordVisibility = false;
  }

  @override
  void dispose() {
    unfocusNode.dispose();
    emailAddressFocusNode?.dispose();
    emailAddressTextController?.dispose();

    passwordFocusNode?.dispose();
    passwordTextController?.dispose();
  }

  /// Action blocks.
  Future signInActionPage(
    BuildContext context, {
    required String? emailAdress,
    required String? passwd,
  }) async {
    String? devUUID;
    ApiCallResponse? loginCall;

    await Future.wait([
      Future(() async {
        FFAppState().email = emailAdress!;
      }),
      Future(() async {
        FFAppState().passwd = passwd!;
      }),
    ]);
    if ((FFAppState().email != '') &&
        (FFAppState().passwd != '')) {
      devUUID = await actions.getDevUUID();
      FFAppState().devUUID = devUUID!;
      loginCall = await PhpGroup.loginCall.call(
        email: FFAppState().email,
        password: FFAppState().passwd,
        uuid: FFAppState().devUUID,
        type: FFAppState().device,
        description: '',
      );
      FFAppState().userUUID = FFAppState().userUUID;
      if (PhpGroup.loginCall.error(
            (loginCall.jsonBody ?? ''),
          ) ==
          false) {
        FFAppState().isLogged = true;

        context.goNamed(
          'homePage',
          extra: <String, dynamic>{
            kTransitionInfoKey: const TransitionInfo(
              hasTransition: true,
              transitionType: PageTransitionType.fade,
            ),
          },
        );
      } else {
        await showModalBottomSheet(
          isScrollControlled: true,
          backgroundColor: Colors.transparent,
          enableDrag: false,
          context: context,
          builder: (context) {
            return GestureDetector(
              onTap: () => unfocusNode.canRequestFocus
                  ? FocusScope.of(context).requestFocus(unfocusNode)
                  : FocusScope.of(context).unfocus(),
              child: Padding(
                padding: MediaQuery.viewInsetsOf(context),
                child: ThrowExceptionWidget(
                  msg: PhpGroup.loginCall.msg(
                    (loginCall?.jsonBody ?? ''),
                  )!,
                ),
              ),
            );
          },
        );

        FFAppState().deleteEmail();
        FFAppState().email = '';

        FFAppState().deletePasswd();
        FFAppState().passwd = '';

        FFAppState().update(() {});
      }
    } else {
      FFAppState().deleteEmail();
      FFAppState().email = '';

      FFAppState().deletePasswd();
      FFAppState().passwd = '';
    }
  }
}
